/**
 * Un ejemplo que modela un Circulo usando POO
 * 
 * @author (Milton Jesús Vera Contreras - miltonjesusvc@ufps.edu.co)
 * @version 0.000000000000001 :) --> Math.sin(Math.PI-Double.MIN_VALUE)
 */
public class FrmCirculo extends javax.swing.JFrame {
    
    private Circulo circulo;
    
    /** Creates new form FrmCirculo */
    public FrmCirculo(Circulo circulo) {
        initComponents();
        this.circulo = circulo;
        setVisible(true);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        panelTitulo = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        panelAdorno = new javax.swing.JPanel();
        lblImagen = new javax.swing.JLabel();
        panelBotones = new javax.swing.JPanel();
        cmdModificarCirculo = new javax.swing.JButton();
        cmdDeterminarPosicion = new javax.swing.JButton();
        cmdAyuda = new javax.swing.JButton();
        paneDatos = new javax.swing.JPanel();
        lblCentroX = new javax.swing.JLabel();
        txtCentroX = new javax.swing.JTextField();
        lblCentroY = new javax.swing.JLabel();
        txtCentroY = new javax.swing.JTextField();
        lblRadio = new javax.swing.JLabel();
        txtRadio = new javax.swing.JTextField();
        lblPuntoX = new javax.swing.JLabel();
        txtPuntoX = new javax.swing.JTextField();
        lblPuntoY = new javax.swing.JLabel();
        txtPuntoY = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Localizador Digital - Puntos");
        setResizable(false);

        panelTitulo.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        panelTitulo.setLayout(new java.awt.BorderLayout());

        jLabel2.setFont(new java.awt.Font("DejaVu Sans", 0, 36));
        jLabel2.setText("Localizador Digital -Círculo");
        panelTitulo.add(jLabel2, java.awt.BorderLayout.CENTER);

        getContentPane().add(panelTitulo, java.awt.BorderLayout.NORTH);

        panelAdorno.setBorder(javax.swing.BorderFactory.createTitledBorder(""));

        lblImagen.setFont(new java.awt.Font("DejaVu Sans", 1, 13));
        lblImagen.setForeground(new java.awt.Color(0, 0, 255));
        lblImagen.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        lblImagen.setIcon(new javax.swing.ImageIcon(getClass().getResource("/planoCirculo.jpg"))); // NOI18N
        lblImagen.setText("Ubicación Desconocida");
        lblImagen.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        lblImagen.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        panelAdorno.add(lblImagen);

        getContentPane().add(panelAdorno, java.awt.BorderLayout.EAST);

        panelBotones.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        panelBotones.setLayout(new java.awt.GridLayout(1, 3));

        cmdModificarCirculo.setText("Actualizar Coordenadas");
        cmdModificarCirculo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdModificarCirculoActionPerformed(evt);
            }
        });
        panelBotones.add(cmdModificarCirculo);

        cmdDeterminarPosicion.setText("Determinar Posición");
        cmdDeterminarPosicion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdDeterminarPosicionActionPerformed(evt);
            }
        });
        panelBotones.add(cmdDeterminarPosicion);

        cmdAyuda.setText("Ayuda");
        cmdAyuda.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdAyudaActionPerformed(evt);
            }
        });
        panelBotones.add(cmdAyuda);

        getContentPane().add(panelBotones, java.awt.BorderLayout.SOUTH);

        paneDatos.setBorder(javax.swing.BorderFactory.createTitledBorder(""));
        paneDatos.setLayout(new java.awt.GridLayout(5, 2));

        lblCentroX.setText("Centro X:");
        paneDatos.add(lblCentroX);

        txtCentroX.setFont(new java.awt.Font("DejaVu Sans", 0, 18));
        txtCentroX.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtCentroX.setText("0.0");
        txtCentroX.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        paneDatos.add(txtCentroX);

        lblCentroY.setText("Centro Y:");
        paneDatos.add(lblCentroY);

        txtCentroY.setFont(new java.awt.Font("DejaVu Sans", 0, 18));
        txtCentroY.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtCentroY.setText("0.0");
        txtCentroY.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        paneDatos.add(txtCentroY);

        lblRadio.setText("Radio:");
        paneDatos.add(lblRadio);

        txtRadio.setFont(new java.awt.Font("DejaVu Sans", 0, 18));
        txtRadio.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtRadio.setText("0.0");
        txtRadio.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        paneDatos.add(txtRadio);

        lblPuntoX.setText("Coordenada X Punto:");
        paneDatos.add(lblPuntoX);

        txtPuntoX.setFont(new java.awt.Font("DejaVu Sans", 0, 18));
        txtPuntoX.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtPuntoX.setText("0.0");
        txtPuntoX.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        paneDatos.add(txtPuntoX);

        lblPuntoY.setText("Coordenada Y Punto:");
        paneDatos.add(lblPuntoY);

        txtPuntoY.setFont(new java.awt.Font("DejaVu Sans", 0, 18));
        txtPuntoY.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        txtPuntoY.setText("0.0");
        txtPuntoY.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        paneDatos.add(txtPuntoY);

        getContentPane().add(paneDatos, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cmdDeterminarPosicionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdDeterminarPosicionActionPerformed
       float x = Float.parseFloat(txtPuntoX.getText());
       float y = Float.parseFloat(txtPuntoY.getText());
       lblImagen.setText(circulo.getPosicionPunto(x, y));
    }//GEN-LAST:event_cmdDeterminarPosicionActionPerformed

    private void cmdModificarCirculoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdModificarCirculoActionPerformed
      circulo.setCentroX(Float.parseFloat(txtCentroX.getText()));
      circulo.setCentroY(Float.parseFloat(txtCentroY.getText()));
      circulo.setRadio(Float.parseFloat(txtRadio.getText()));
      lblImagen.setText("Ubicacion Desconocida");
      javax.swing.JOptionPane.showMessageDialog(this, "Círculo Actualizado");
}//GEN-LAST:event_cmdModificarCirculoActionPerformed

    private void cmdAyudaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdAyudaActionPerformed
      javax.swing.JOptionPane.showMessageDialog(this, "Determina la ubicación de un Punto\nRelativa a un Círculo.");
    }//GEN-LAST:event_cmdAyudaActionPerformed

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cmdAyuda;
    private javax.swing.JButton cmdDeterminarPosicion;
    private javax.swing.JButton cmdModificarCirculo;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel lblCentroX;
    private javax.swing.JLabel lblCentroY;
    private javax.swing.JLabel lblImagen;
    private javax.swing.JLabel lblPuntoX;
    private javax.swing.JLabel lblPuntoY;
    private javax.swing.JLabel lblRadio;
    private javax.swing.JPanel paneDatos;
    private javax.swing.JPanel panelAdorno;
    private javax.swing.JPanel panelBotones;
    private javax.swing.JPanel panelTitulo;
    private javax.swing.JTextField txtCentroX;
    private javax.swing.JTextField txtCentroY;
    private javax.swing.JTextField txtPuntoX;
    private javax.swing.JTextField txtPuntoY;
    private javax.swing.JTextField txtRadio;
    // End of variables declaration//GEN-END:variables
    
}
